%define _libdir64 %{_prefix}/lib64

Name: libwpd
Summary: Library for reading and converting WordPerfect documents
Version: 0.9.4
Release: 2
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.bz2
Group: System Environment/Libraries
URL: http://libwpd.sf.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
License: LGPLv2+
BuildRequires: glib2-devel >= 2.0.0

%description
Library that handles Word Perfect documents.

The library is available as 32-bit and 64-bit.


%package tools
Summary: Tools to transform WordPerfect Documents into other formats
Group: Applications/Publishing

%description tools
Tools to transform WordPerfect Documents into other formats.
Currently supported: HTML, raw, text.


%package devel
Requires: libwpd = %{version}-%{release}
Requires: glib2-devel >= 2.0.0, pkg-config
Summary: Files for developing with libwpd
Group: Development/Libraries

%description devel
Includes and definitions for developing with libwpd.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc -q64" or "gcc -maix64".


%prep
%setup -q
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --enable-shared --disable-static \
    --disable-werror \
    --without-docs
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --enable-shared --disable-static \
    --disable-werror \
    --without-docs
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
for i in 0.9 stream-0.9 ; do
    /usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/%{name}-${i}.a ${RPM_BUILD_ROOT}%{_libdir64}/%{name}-${i}.so*
done

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/COPYING 32bit/CREDITS 32bit/README
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files tools
%defattr(-,root,system,-)
%{_bindir}/wpd2*
/usr/bin/wpd2*


%files devel
%defattr(-,root,system,-)
%doc 32bit/HACKING 32bit/TODO
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/*
%{_libdir64}/pkgconfig/*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Mon Jul 30 2012 Michael Perzl <michael@perzl.org> - 0.9.4-2
- fixed wrong dependency on pkg-config

* Fri Jul 06 2012 Michael Perzl <michael@perzl.org> - 0.9.4-1
- first version for AIX V5.1 and higher
